import createPlayerDB from "./createPlayerDB"
import createTokenDB, { RawToken } from "./createTokenDB"
import type { API } from "./sendError"
import { Player, Token } from "@prisma/client"

async function getTokenFromCookie<T>(
  context: API<T>,
  next: (
    refreshToken: RawToken,
    newPlayer?: { player: Player; newToken: RawToken; newTokenDB: Token }
  ) => void
) {
  const type = "REFRESH"
  const value = context.req.cookies.token

  // Checking for cookie presens, because it is necessary
  if (!value) {
    return createPlayerDB((player) =>
      createTokenDB(player, type, (newToken, newTokenDB) =>
        next(newToken, { player, newToken, newTokenDB })
      )
    )
  }
  return next({ value, type })
}

export default getTokenFromCookie
